-- YGREC8/INC16.vhdl
-- created sam. nov. 11 23:55:05 CET 2017 by Yann Guidon (whygee@f-cpu.org)
-- version jeu. nov. 16 02:51:52 CET 2017 : uses SLV shorthands from YGREC8/YGREC8_def.vhdl
-- Released under the GNU AGPLv3 license
--
-- This is another increment unit of YGREC8,
-- used to increment the timer.
-- This dumb version uses the built-in + operator

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.ygrec8_def.all;

entity INC16 is
  port(
    A : in  SLV16;
    C, Y : out SLV16;
    V : out SL);
end INC16;

architecture classic of INC16 is
  signal sumAux : unsigned(16 downto 0);
begin
  sumAux <= unsigned('0' & A) + 1;
  Y <= std_logic_vector(sumAux(15 downto 0));
  C <= std_logic_vector(sumAux(15 downto 0)) xor A; -- should be optimised out to provide the carry chain's pulses
  V <= SL(sumAux(16));
end classic;
