-- YGREC8/INC16_tb.vhdl
-- version lun. nov. 13 01:45:27 CET 2017 by Yann Guidon (whygee@f-cpu.org)
-- version jeu. nov. 16 02:51:52 CET 2017 : uses SLV shorthands from YGREC8/YGREC8_def.vhdl
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.ygrec8_def.all;
    use work.ygrec8_utils.all;

entity INC16_tb is
end INC16_tb;

architecture plip of INC16_tb is
  signal V : SL := '0';
  signal A, Y : SLV16 := "0000000000000000";
begin

  tb: entity INC16 port map (
     A => A,
     Y => Y,
     V => V);

  bench: process
    variable i: integer := 0;
    variable expected : SLV17;
  begin

    for i in 0 to 65535 loop
      A <= std_logic_vector(to_unsigned(i, 16));
      wait for 1 ns;

      expected := std_logic_vector(to_unsigned(i+1, 17));
      if expected /= (V & Y) then
        report "Error at " & integer'image(i)
          & " " & SLV_to_bin(A)
          & " " & std_logic'image(V)
          & " " & SLV_to_bin(Y);
      end if;
    end loop;

    wait;
  end process;

end plip;
