-- MUX8.vhdl
-- created dim. janv. 28 23:45:28 CET 2018 by whygee@f-cpu.org
--
-- A MUX8 using balanced control of MUX2s
-- All 6 possible versions are provided.

Library ieee;
    use ieee.std_logic_1164.all;
Library work;
    use work.all;
    use work.ygrec8_def.all;

entity MUX8 is
  port(Adr : in SLV3;
         I : in SLV8;
         S : out SL);
end MUX8;

architecture ABC of MUX8 is
  Signal tA0, tA1, tA2, tA3, tB0, tB1 : SL;
begin
  tA0 <= I(0) when Adr(0)='0' else I(1);
  tA1 <= I(2) when Adr(0)='0' else I(3);
  tA2 <= I(4) when Adr(1)='0' else I(6);
  tA3 <= I(5) when Adr(1)='0' else I(7);

  tB0 <= tA0 when Adr(1)='0' else tA1;
  tB1 <= tA2 when Adr(0)='0' else tA3;

   S  <= tB0 when Adr(2)='0' else tB1;
end ABC;

architecture BAC of MUX8 is
  Signal tA0, tA1, tA2, tA3, tB0, tB1 : SL;
begin
  tA0 <= I(0) when Adr(1)='0' else I(2);
  tA1 <= I(1) when Adr(1)='0' else I(3);
  tA2 <= I(4) when Adr(0)='0' else I(5);
  tA3 <= I(6) when Adr(0)='0' else I(7);

  tB0 <= tA0 when Adr(0)='0' else tA1;
  tB1 <= tA2 when Adr(1)='0' else tA3;

   S  <= tB0 when Adr(2)='0' else tB1;
end BAC;

architecture CBA of MUX8 is
  Signal tA0, tA1, tA2, tA3, tB0, tB1 : SL;
begin
  tA0 <= I(0) when Adr(2)='0' else I(4);
  tA1 <= I(2) when Adr(2)='0' else I(6);
  tA2 <= I(1) when Adr(1)='0' else I(3);
  tA3 <= I(5) when Adr(1)='0' else I(7);

  tB0 <= tA0 when Adr(1)='0' else tA1;
  tB1 <= tA2 when Adr(2)='0' else tA3;

   S  <= tB0 when Adr(0)='0' else tB1;
end CBA;

architecture BCA of MUX8 is
  Signal tA0, tA1, tA2, tA3, tB0, tB1 : SL;
begin
  tA0 <= I(0) when Adr(1)='0' else I(2);
  tA1 <= I(4) when Adr(1)='0' else I(6);
  tA2 <= I(1) when Adr(2)='0' else I(5);
  tA3 <= I(3) when Adr(2)='0' else I(7);

  tB0 <= tA0 when Adr(2)='0' else tA1;
  tB1 <= tA2 when Adr(1)='0' else tA3;

   S  <= tB0 when Adr(0)='0' else tB1;
end BCA;

architecture ACB of MUX8 is
  Signal tA0, tA1, tA2, tA3, tB0, tB1 : SL;
begin
  tA0 <= I(0) when Adr(0)='0' else I(1);
  tA1 <= I(4) when Adr(0)='0' else I(5);
  tA2 <= I(2) when Adr(2)='0' else I(6);
  tA3 <= I(3) when Adr(2)='0' else I(7);

  tB0 <= tA0 when Adr(2)='0' else tA1;
  tB1 <= tA2 when Adr(0)='0' else tA3;

   S  <= tB0 when Adr(1)='0' else tB1;
end ACB;

architecture CAB of MUX8 is
  Signal tA0, tA1, tA2, tA3, tB0, tB1 : SL;
begin
  tA0 <= I(0) when Adr(2)='0' else I(4);
  tA1 <= I(1) when Adr(2)='0' else I(5);
  tA2 <= I(2) when Adr(0)='0' else I(3);
  tA3 <= I(6) when Adr(0)='0' else I(7);

  tB0 <= tA0 when Adr(0)='0' else tA1;
  tB1 <= tA2 when Adr(2)='0' else tA3;

   S  <= tB0 when Adr(1)='0' else tB1;
end CAB;

