-- MUX8_tb.vhdl
-- created lun. janv. 29 02:58:18 CET 2018 by whygee@f-cpu.org
--
-- Test all the MUX8s flavours

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.ygrec8_def.all;
    use work.ygrec8_utils.all;

entity MUX8_tb is
end MUX8_tb;

architecture test of MUX8_tb is
  Signal v8 : SLV8 := "00000000";
  Signal A  : SLV3 := "000";
  Signal S  : SLV6 := "000000";
begin

  tABC: entity work.MUX8(ABC) port map (Adr=>A, I=>v8, S=>S(0));
  tBAC: entity work.MUX8(BAC) port map (Adr=>A, I=>v8, S=>S(1));
  tCBA: entity work.MUX8(CBA) port map (Adr=>A, I=>v8, S=>S(2));
  tBCA: entity work.MUX8(BCA) port map (Adr=>A, I=>v8, S=>S(3));
  tACB: entity work.MUX8(ACB) port map (Adr=>A, I=>v8, S=>S(4));
  tCAB: entity work.MUX8(CAB) port map (Adr=>A, I=>v8, S=>S(5));

  bench: process
    variable i : integer := 0;
  begin

    for i in 0 to 7 loop
      A <= std_logic_vector(to_unsigned(i, 3));

      v8 <= "00000000";  wait for 1 ns;
      assert S = "000000"
        report "#" & integer'image(i)
             & ": S=" & SLV_to_bin(S)
             & " expected=000000"
        severity failure; -- warning;

      v8(i) <= '1';  wait for 1 ns;
      assert S = "111111"
        report "#" & integer'image(i)
             & ": S=" & SLV_to_bin(S)
             & " expected=111111"
        severity failure; -- warning;

      v8 <= "11111111";  wait for 1 ns;
      assert S = "111111"
        report "#" & integer'image(i)
             & ": S=" & SLV_to_bin(S)
             & " expected=111111"
        severity failure; -- warning;

      v8(i) <= '0';  wait for 1 ns;
      assert S = "000000"
        report "#" & integer'image(i)
             & ": S=" & SLV_to_bin(S)
             & " expected=000000"
        severity failure; -- warning;

    end loop;

    wait;
  end process;

end test;
